<?php
//MyStatus
//Created by euantor for MyBBSource/360Elites

 
// Disallow direct access to this file. For security reasons, DO NOT REMOVE
if(!defined("IN_MYBB"))
{
    die("You Cannot Access This File Directly");
}

$plugins->add_hook("member_profile_end", "mystatus_prof");
$plugins->add_hook("usercp_start", "mystatus_ucp");
$plugins->add_hook("postbit", "mystatus_postbit");
$plugins->add_hook("index_start", "mystatus_latestupdates_block");

//User permissions

$plugins->add_hook("admin_formcontainer_end", "mystatus_edit_group");
$plugins->add_hook("admin_user_groups_edit_commit", "mystatus_edit_group_do");


function mystatus_info()
{
	return array(
		"name"			=> "mystatus",
		"description"	=> "Allow users to set a custom status from their profile like in IPB3.",
		"website"		=> "http://www.mybbsource.com",
		"author"		=> "euantor",
		"authorsite"	=> "http://www.360elites.net",
		"version"		=> "3.1",
		"guid" 			=> "c649a3585155cad7c04e91d05f04b6d6",
		"compatibility" => "*"
	);
}

function mystatus_install()
{
	global $mybb, $db, $cache;
		
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` ADD `mystatus` VARCHAR( 140 ) NOT NULL DEFAULT 'I have no status', ADD `mystatustime` DATETIME");
	$db->write_query("CREATE TABLE `".TABLE_PREFIX."statuses` (`statid` INT NOT NULL AUTO_INCREMENT PRIMARY KEY,`uid` INT NOT NULL ,`stype` VARCHAR( 6 ) NOT NULL DEFAULT 'status',`statustext` VARCHAR( 140 ) NOT NULL ,`statustime` DATETIME NOT NULL)");

	// Creates fields for groups-based permissions
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `canusemystatus` INT(1) NOT NULL DEFAULT '0';");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` ADD `canmodstatuses` INT(1) NOT NULL DEFAULT '0';");

	
	// Give access to send and edit own comments to ALL USERGROUPS
	$db->write_query('UPDATE '.TABLE_PREFIX.'usergroups SET canusemystatus = "1"');
	// Give access to EDIT & DELETE (all comments) to Administrators
	$db->write_query('UPDATE '.TABLE_PREFIX.'usergroups SET canmodstatuses = "1" WHERE gid = "4"');
	
	$sql = $db->query("SELECT uid FROM `".TABLE_PREFIX."users`");
	while($row = $db->fetch_array($sql))
	{
		$db->write_query("INSERT INTO `".TABLE_PREFIX."statuses` (`statid` ,`uid` ,`stype` ,`statustext` ,`statustime`)VALUES (NULL , '".$row['uid']."', 'status', 'I have no status', NOW())");
	}
	
	$cache->update_usergroups();
}

function mystatus_is_installed()
{
	global $db;
	
	if($db->table_exists("statuses"))
	{
		return true;
	}
	else {
		return false;
	}
	
}

function mystatus_activate() 
{	
	global $mybb, $db;
	
	$settings_group = array(
        "gid" => "",
        "name" => "mystatus",
        "title" => "MyStatus",
        "description" => "Settings for the MyStatus plugin.",
        "disporder" => "48",
        "isdefault" => "0",
    );
		
    $db->insert_query("settinggroups", $settings_group);
    $gid = $db->insert_id();
	
	$setting_1 = array(
		"name"			=> "mystatusenable",
		"title"			=> "Enable plugin?",
		"description"	=> "Do you want to enable the MyStatus plugin?",
		"optionscode"	=> "yesno",
		"value"			=> "1",
		"disporder"		=> "1",
		"gid"			=> $gid,
	);
	
	$db->insert_query("settings", $setting_1);
		
	$setting_2 = array(
		"name"			=> "mystatussidebarnumber",
		"title"			=> "Number of statuses to display",
		"description"	=> "How many status updates do o wish to display in the \"Latest Statuses\" block?",
		"optionscode"	=> "text",
		"value"			=> "10",
		"disporder"		=> "1",
		"gid"			=> $gid,
	);
	
	$db->insert_query("settings", $setting_2);		
		
	
			
		
	$template_1 = array(
		"title"		=> 'mystatus',
		"template"	=> '<br />
<table border="0" cellspacing="{$theme[\\\'borderwidth\\\']}" cellpadding="{$theme[\\\'tablespace\\\']}" class="tborder">
<tr>
<td colspan="2" class="thead"><strong>My Current Status</strong></td>
</tr>
{$mystatusedit}
<tr>
<td class="tcat"><strong>Recent Status Updates</strong></td>
</tr>
<tbody class="recentstatuses">
{$currentstatus}
</tbody>
</table>',
		"sid"		=> "-1",
		"version"	=> "1.0",
		"dateline"	=> TIME_NOW
	);

	$db->insert_query("templates", $template_1);
	
	$template_2 = array(
		"title"		=> 'mystatusedit',
		"template"	=> '<tr>
<td class="trow1">
		<div class="block">
<div class="status_alert pm_alert" style="display: none;">
<strong>Oops!</strong> There was an error updating your status.
</div>
	<div class="form">
	<form method="post" action="process-mystatus.php">
	<div class="element">
		<label>Status</label>
		<input type="text" name="status" class="text" />
		<input type="hidden" name="uid" value="{$memprofile[\\\'uid\\\']}" /> 
		<input type="submit" id="submit" value="Update Status" />
	</div>
	<div class="element">
		<div class="validation_loading mystatus_loading" style="display: none;"></div>
	</div>
	</form>
	</div>
</div>
</td>
</tr>',
		"sid"		=> "-1",
		"version"	=> "1.0",
		"dateline"	=> TIME_NOW
	);

	$db->insert_query("templates", $template_2);
	
					$template_3 = array(
		"title"		=> 'mystatuseditucp',
		"template"	=> '<tr>
<td class="trow1" colspan="2">
		<div class="block">
<div class="status_alert pm_alert" style="display: none;">
<strong>Oops!</strong> There was an error updating your status.
</div>
	<div class="form">
	<form method="post" action="process-mystatus.php">
	<div class="element">
		<label>Status</label>
		<input type="text" name="status" class="text" />
		<input type="hidden" name="uid" value="{$mybb->user[\\\'uid\\\']}" />
		<input type="submit" id="submit" value="Update Status" />
	</div>
	<div class="element">
		<div class="validation_loading mystatus_loading" style="display: none;"></div>
	</div>
	</form>
	</div>
</div>
</td>
</tr>',
		"sid"		=> "-1",
		"version"	=> "1.0",
		"dateline"	=> TIME_NOW
	);

	$db->insert_query("templates", $template_3);
	
	$template_4 = array(
		"title"		=> 'lateststatuses',
		"template"	=> '<br /><table border="0" cellspacing="{$theme[\\\'borderwidth\\\']}" cellpadding="{$theme[\\\'tablespace\\\']}" class="tborder">
<tr>
<td colspan="2" class="thead" colspan="2"><strong>Latest Status Updates</strong></td>
</tr>
{$mystatusedit}
{$lateststatusupdates}
</table><br />',
		"sid"		=> "-1",
		"version"	=> "1.0",
		"dateline"	=> TIME_NOW
	);

	$db->insert_query("templates", $template_4);	

	require "../inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", '#{\$signature}#', "{\$signature}\n{\$mystatus}");
	find_replace_templatesets("usercp", '#{\$latest_subscribed}#', "{\$mystatus}\n{\$latest_subscribed}");
	find_replace_templatesets("postbit", '#'.preg_quote('{$post[\'onlinestatus\']}<br />').'#', "{\$post['onlinestatus']}<br />{\$post['mystatus']}<br />");
	find_replace_templatesets("postbit_classic", '#'.preg_quote('{$post[\'onlinestatus\']}<br />').'#', "{\$post['onlinestatus']}<br />{\$post['mystatus']}<br />");
	find_replace_templatesets("headerinclude", "#".preg_quote("<script type=\"text/javascript\" src=\"{\$mybb->settings['bburl']}/jscripts/popup_menu.js?ver=1600\"></script>")."#i", "<script type=\"text/javascript\" src=\"{\$mybb->settings['bburl']}/jscripts/popup_menu.js?ver=1600\"></script>\n<script type=\"text/javascript\" src=\"http://code.jquery.com/jquery-latest.js\"></script>"); 
	find_replace_templatesets("headerinclude", "#".preg_quote("<script type=\"text/javascript\" src=\"{\$mybb->settings['bburl']}/jscripts/popup_menu.js?ver=1600\"></script>")."#i", "<script type=\"text/javascript\" src=\"{\$mybb->settings['bburl']}/jscripts/popup_menu.js?ver=1600\"></script>\n<script type=\"text/javascript\" src=\"{\$mybb->settings['bburl']}/jscripts/mystatus.js\"></script>"); 
	rebuild_settings();
}

function mystatus_deactivate() 
{
	global $mybb, $db;
	
	    $query = $db->simple_select("settinggroups", "gid", "name='mystatus'");
    	$gid = $db->fetch_field($query, 'gid');
		$db->delete_query("settinggroups","gid='".$gid."'");
		$db->delete_query("settings","gid='".$gid."'");
		$db->delete_query("templates","title='mystatus'");
		$db->delete_query("templates","title='mystatusedit'");
		$db->delete_query("templates","title='mystatuseditucp'");
		$db->delete_query("templates","title='lateststatuses'");
		
		require "../inc/adminfunctions_templates.php";
		find_replace_templatesets("member_profile", '#'.preg_quote('{$mystatus}').'#', '',0);
		find_replace_templatesets("usercp", '#'.preg_quote('{$mystatus}').'#', '',0);
		find_replace_templatesets("postbit", '#'.preg_quote('{$post[\'mystatus\']}<br />').'#', '',0);
		find_replace_templatesets("postbit_classic", '#'.preg_quote('{$post[\'mystatus\']}<br />').'#', '',0);
		find_replace_templatesets("headerinclude", "#".preg_quote("<script type=\"text/javascript\" src=\"\{\$mybb->settings['bburl']}/jscripts/mystatus.js\"></script>")."#i", "", 0); 
		find_replace_templatesets("headerinclude", "#".preg_quote("<script type=\"text/javascript\" src=\"http://code.jquery.com/jquery-latest.js\"></script>")."#i", "", 0); 

    rebuild_settings();

}

function mystatus_uninstall()
{
	global $mybb, $db;
	$db->write_query("DROP TABLE `".TABLE_PREFIX."statuses`");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."usergroups` DROP `canusemystatus` , DROP `canmodstatuses` ;");
	$db->write_query("ALTER TABLE `".TABLE_PREFIX."users` DROP `mystatus` , DROP `mystatustime`;"); 
}


function mystatus_prof() 
{
	global $mybb, $theme, $templates, $db, $memprofile, $mystatusedit, $mystatus, $currentstatus, $cache;
	
	
	$usergroups_cache = $cache->read("usergroups");	
	
	if ($mybb->settings['mystatusenable'] == 1 && $usergroups_cache[$memprofile['usergroup']]['canusemystatus'] == 1) {
		$sql =  $db->query("SELECT `statustext`, `statustime`, `statid` FROM `".TABLE_PREFIX."statuses` WHERE `uid` = ".$memprofile['uid']." ORDER BY ABS(statustime) DESC LIMIT 0,".$mybb->settings['mystatussidebarnumber'].";"); 
		
		while($row = $db->fetch_array($sql)) {
			$currentstatus = $currentstatus.'<tr><td class="trow2"><span class="showstatus" id="currentstatus">'.$row['statustext'].'</span><br />';
			
			if ($mybb->user['uid'] == $memprofile['uid'] || $mybb->usergroup['canmodstatuses'] != 0) {
				$currentstatus = $currentstatus.'<span class="smalltext right"><a href="process-mystatus.php?action=delete&statid='.$row['statid'].'">Delete</a> | '.$row['statustime'].'</td></tr>';
			}
			else {
				$currentstatus = $currentstatus.'<span class="smalltext right">'.$row['statustime'].'</td></tr>';
			}
		}
				
			//status editing
			if ($mybb->user['uid'] == $memprofile['uid'] || $mybb->usergroup['canmodstatuses'] != 0) {
				eval("\$mystatusedit = \"".$templates->get("mystatusedit")."\";");
			}	
		
			//showing current status
			eval("\$mystatus = \"".$templates->get("mystatus")."\";");
	}
			
}

function mystatus_ucp() 
{
	global $mybb, $theme, $templates, $db, $mystatusedit, $mystatus, $currentstatus;
	
	
		if ($mybb->settings['mystatusenable'] == 1 && $mybb->usergroup['canusemystatus'] != 0) {
			//grabbing the current status
		$sql =  $db->query("SELECT `statid`, `statustext`, `statustime` FROM `".TABLE_PREFIX."statuses` WHERE `uid` = ".$mybb->user['uid']." ORDER BY ABS(statustime) DESC LIMIT 0,".$mybb->settings['mystatussidebarnumber'].";"); 
		
		while($row = $db->fetch_array($sql)) {
			$currentstatus = $currentstatus.'<tr><td class="trow2"><div class="showstatus" id="currentstatus">'.$row['statustext'].'</div><span class="smalltext right"><a href="process-mystatus.php?action=delete&statid='.$row['statid'].'">Delete</a> | '.$row['statustime'].'</td></tr>';
		}
			
			eval("\$mystatusedit = \"".$templates->get("mystatuseditucp")."\";");		
			eval("\$mystatus = \"".$templates->get("mystatus")."\";");
		}			
}

function mystatus_postbit($post)
{
    global $mybb, $theme, $templates, $cache; 
    // reset it first
    // whatever $post['mystatus'] is, even if it's empty, will be referred to as $currentstatus for now
    $currentstatus = $post['mystatus'];
    $usergroups_cache = $cache->read("usergroups");
	
    if($mybb->settings['mystatusenable'] == 1 && $usergroups_cache[$post['usergroup']]['canusemystatus'] == 1)
    {
        // now set $post['mystatus'] to display the $currentstatus
        $post['mystatus'] = '<span class="smalltext">'.$currentstatus.'</span>';
        
        //status editing
        if($mybb->user['uid'] == $post['uid'] || $mybb->usergroup['canmodstatuses'] != 0)
        {
            // here we can just use $post['mystatus']
            $post['mystatus'] = '<span class="smalltext post-mystatus-'.$post['pid'].'">'.$post['mystatus'].' <a href="" onclick="MyBB.popupWindow(\''.$mybb->settings['bburl'].'/process-mystatus.php?action=postbitedit&updateuid='.$post['uid'].'\', \'MyStatus Update\', 350, 115);">Edit</a></span>';
        }
    }
	else {
		$post['mystatus'] = "";
	}
}

function mystatus_latestupdates_block()
{
		global $mybb, $theme, $templates, $db, $lateststatusupdates, $lateststatuses, $mystatusedit;
	
		$sql = $db->query("SELECT `".TABLE_PREFIX."statuses`.`uid`, statid, statustext, statustime, avatar, username FROM `".TABLE_PREFIX."statuses` INNER JOIN `".TABLE_PREFIX."users` ON `".TABLE_PREFIX."statuses`.`uid` = `".TABLE_PREFIX."users`.`uid` ORDER BY ABS(`".TABLE_PREFIX."statuses`.`statustime`) DESC LIMIT 0, ".$mybb->settings['mystatussidebarnumber']);
		while($row = $db->fetch_array($sql)) {
			$lateststatusupdates = $lateststatusupdates.'<tr><td class="trow2" width="32"><img src="'.$row['avatar'].'" alt="" width="32" height="32" /></td><td class="trow2"><a href="member.php?action=profile&uid='.$row['uid'].'">@'.$row['username'].'</a>: <strong>'.$row['statustext'].'</strong><br />';
			
			if ($mybb->user['uid'] == $row['uid'] || $mybb->usergroup['canmodstatuses'] != 0) {
				$lateststatusupdates = $lateststatusupdates.'<span class="smalltext right"><a href="process-mystatus.php?action=delete&statid='.$row['statid'].'">Delete</a> | '.$row['statustime'].'</td></tr>';
			}
			else {
				$lateststatusupdates = $lateststatusupdates.'<span class="smalltext right">'.$row['statustime'].'</td></tr>';
			}
		
		}
				
		if ($mybb->usergroup['canusemystatus'] != 0) {
			eval("\$mystatusedit = \"".$templates->get("mystatuseditucp")."\";");
		}
		
		eval("\$lateststatuses = \"".$templates->get("lateststatuses")."\";");
}


//User permissions Functions

function mystatus_edit_group()
{
	global $run_module, $form_container, $lang, $form, $mybb;

	// If the current tab is "Users & Permissions", add plugin options
	if($run_module == 'user' && !empty($form_container->_title) & !empty($lang->users_permissions) & $form_container->_title == $lang->users_permissions)
	{

		// And generate the checkbox
		$mystatus_options = array();
		$mystatus_options[] = $form->generate_check_box('canusemystatus', 1, "Can use statuses?", array('checked' => $mybb->input['canusemystatus']));
		$mystatus_options[] = $form->generate_check_box('canmodstatuses', 1, "Can moderate statuses of others?", array('checked' => $mybb->input['canmodstatuses']));

		
		$form_container->output_row("Mystatus", '', '<div class="group_settings_bit">'.implode('</div><div class="group_settings_bit">', $mystatus_options).'</div>');
	}
}

// Update group-bassed permission
function mystatus_edit_group_do()
{
	global $updated_group, $mybb;

	$updated_group['canusemystatus'] = $mybb->input['canusemystatus'];
	$updated_group['canmodstatuses'] = $mybb->input['canmodstatuses'];
}

?>